import { ElementX } from '..';
import { Record } from '.';
export declare enum EventTypes {
    scroll = "scroll",
    resize = "resize",
    form = "form"
}
export declare enum MouseTypes {
    click = "click",
    move = "move"
}
export declare type MouseOptions = {
    click?: boolean;
    mousemove?: boolean;
};
export declare type EventOptions = {
    scroll?: boolean;
    resize?: boolean;
    form?: boolean;
    domsWillScroll?: string[];
};
export declare type Listener = {
    target: Document | ElementX | Window;
    event: string;
    callback: EventListenerOrEventListenerObject;
    options?: AddEventListenerOptions | boolean;
};
export interface EventReocrd extends Record {
    type: EventTypes;
    x?: number;
    y?: number;
    w?: number;
    h?: number;
    target?: number;
    k?: string;
    v?: number | string;
}
export interface MouseReocrd extends Record {
    type: MouseTypes;
    x?: number;
    y?: number;
}
