import { Record } from '.';
export declare enum HttpRockets {
    beacon = "beacon",
    fetch = "fetch",
    xhr = "xhr"
}
export declare enum HttpEndTypes {
    fetcherror = "fetcherror",
    fetchend = "fetchend",
    xhrerror = "xhrerror",
    xhrabort = "xhrabort",
    xhrtimeout = "xhrtimeout",
    xhrend = "xhrend"
}
export declare type HttpOptions = {
    beacon?: boolean;
    fetch?: boolean;
    xhr?: boolean;
};
export interface HttpRecord extends Record {
    type: HttpRockets;
    id?: string;
    url: string;
    headers?: {
        [key: string]: any;
    };
    input?: any[];
    payload?: any;
    response?: any;
    method?: string;
    status?: number;
    errmsg?: any;
}
