import { Record } from '.';
export declare enum DOMMutationTypes {
    attr = "attr",
    node = "node",
    text = "text"
}
export interface NodeMutationData {
    index?: number;
    type: 'text' | 'ele';
    target?: number;
    textContent?: string;
    html?: string;
}
export interface DOMMutationRecord extends Record {
    type: DOMMutationTypes;
    target: number;
    attr?: {
        k: string;
        v: string;
    };
    prev?: number;
    next?: number;
    add?: NodeMutationData[];
    remove?: NodeMutationData[];
    text?: string;
    html?: string;
}
