import { ID_KEY } from '../constants';
class NikonD7000DSLRClass {
    constructor() {
        this.map = new Map();
        this.inited = false;
        this.id = 0;
        this.buffer = (ele) => {
            let recorderId = this.map.get(ele) || this.newId();
            this.map.set(ele, recorderId);
            this.mark(ele, recorderId);
            return recorderId;
        };
        this.bufferNewElement = (ele) => {
            this.buffer(ele);
            if (ele.childElementCount) {
                Array.prototype.slice
                    .call(ele.children)
                    .forEach(chEle => this.bufferNewElement(chEle));
            }
        };
        this.getRecordIdByElement = (ele) => {
            return this.map.get(ele);
        };
    }
    takeSnapshotForPage() {
        console.time('[Snapshot for page]');
        Array.prototype.slice
            .call(document.querySelectorAll('*'))
            .forEach(this.buffer);
        this.latestSnapshot = document.documentElement.outerHTML;
        Array.prototype.slice
            .call(document.querySelectorAll('*'))
            .forEach((node) => {
            this.unmark(node);
        });
        console.timeEnd('[Snapshot for page]');
        return this.latestSnapshot;
    }
    newId() {
        this.id += 1;
        return this.id;
    }
    mark(ele, id) {
        ele.setAttribute(ID_KEY, id);
    }
    unmark(ele, isDeep = false) {
        const { removeAttribute } = ele;
        removeAttribute && ele.removeAttribute(ID_KEY);
        if (isDeep && ele.childElementCount) {
            Array.prototype.slice
                .call(ele.children)
                .forEach(chEle => this.unmark(chEle));
        }
    }
}
const NikonD7000 = new NikonD7000DSLRClass();
export default NikonD7000;
